<?php
/**
 * Exit if accessed directly
 */

// alm 20170819
// dropdown users show "company (legal representative) if company not empty
// find_user now find in company name and is casse and accents independant

if ( !defined( 'ABSPATH' ) ) {
    exit; 
}
if ( !class_exists( 'WordPress_Cooperative_Admin' ) ) {
  class WordPress_Cooperative_Admin {
        public function __construct() {
            global $wpcoop;
            // copy some parameters from wpcoop
            $this->plugin_version = $wpcoop->plugin_version;
            $this->plugin_prefix = $wpcoop->plugin_prefix;

            $this->plugin_textdomain = $wpcoop->plugin_textdomain;
            
            $this->plugin_capability = $wpcoop->plugin_capability;
            
            $this->possible_statuses = $wpcoop->settings->get_possible_statuses();
            
            $this->workflow = $wpcoop->settings->get_workflow();
            
            $this->possible_statuses = $wpcoop->settings->get_possible_statuses();
            
            $this->plugin_usersubs_meta=$wpcoop->plugin_usersubs_meta;
            
            // some parameters for this class
            // admin page slug name
            $this->class_slug = 'wpcoop';
            
            // when in admin menu, add admin pages subpage and settings
            add_action( 'admin_menu', array( $this, 'setup_admin_pages' ));
 
            
            // add contact fields         
            add_filter('user_contactmethods', array($this, 'modify_contactmethods'));   
            
            // add profile category
            add_action( 'show_user_profile', array($this,'add_profile_category_fields' ));
            add_action( 'edit_user_profile', array($this,'add_profile_category_fields' ));
            add_action( 'personal_options_update', array($this,'save_profile_category_fields' ));
            add_action( 'edit_user_profile_update', array($this,'save_profile_category_fields' ));
            
         
        }

        public function setup_admin_pages() {
            // Add settings page for users who can edit plugins
            // add_menu_page( string $page_title,
            //                   string $menu_title, string $capability, string $menu_slug, callable $function = '', string $icon_url = '', int $position = null )
            $mp=add_menu_page( __('WpCoop Coop Management',$this->plugin_textdomain),
                           __('WpCoop',$this->plugin_textdomain),
                           $this->plugin_capability,
                           $this->class_slug,
                           array($this, 'admin_main_page'),
                           '', // icone  url ?
                           '3' // position
                         );
            
            // add help to menu page 
            add_action('load-'.$mp, array($this, 'page_help'));
           
            $smp=add_submenu_page($this->class_slug, __('WpCoop Subscribers',$this->plugin_textdomain),
                             __('Subscribers',$this->plugin_textdomain),
                             $this->plugin_capability,
                             'add1',
                             array($this, 'admin_add_subpage1')
                             );  
            // add help to submenu page 1
            add_action('load-'.$smp, array($this, 'subpage1_help'));
          
                
            $smp=add_submenu_page($this->class_slug, __('WpCoop Subscriptions',$this->plugin_textdomain),
                             __('Subscriptions',$this->plugin_textdomain),
                             $this->plugin_capability,
                             'add2',
                             array($this, 'admin_add_subpage2')
                             );                             
            // add help to submenu page 2
            add_action('load-'.$smp, array($this, 'subpage2_help'));
          
            // sub-menu actions           
            $smp=add_submenu_page($this->class_slug, __('WpCoop Actions',$this->plugin_textdomain),
                             __('Actions',$this->plugin_textdomain),
                             $this->plugin_capability,
                             'actions',
                             array($this, 'admin_add_actions')
                             );                             
            // add help to submenu actions
            add_action('load-'.$smp, array($this, 'actions_help'));

            // sub-menu meetings           
            $smp=add_submenu_page($this->class_slug, __('WpCoop Meetings',$this->plugin_textdomain),
                             __('Meetings',$this->plugin_textdomain),
                             $this->plugin_capability,
                             'meetings',
                             array($this, 'admin_add_meetings')
                             );                             
            // add help to submenu meetings
            add_action('load-'.$smp, array($this, 'meetings_help'));
        }
      
        public function admin_add_meetings() {
          print_tab($_REQUEST);  
          $tabs= array(
                  array( 'slug'=>'ca',  'caption'=>__('CA',$this->plugin_textdomain)),
                  array( 'slug'=>'ago',  'caption'=>__('AGO',$this->plugin_textdomain)),
                  array( 'slug'=>'agoe', 'caption'=>__('AGOE',$this->plugin_textdomain)),
                  array( 'slug'=>'age',  'caption'=>__('AGE',$this->plugin_textdomain))
                );
          /////// get active tab
          $active_tab='ca';
          if( isset( $_GET[ 'tab' ] ) ) {
            foreach($tabs as $tab) {
              if($_GET[ 'tab' ]==$tab['slug']) $active_tab=$tab['slug'];
            }
          }
          $args=array(
                    'tab'=>$active_tab, 
                    'items'=>5,  // default number of items
                    'fields'=>array(
                      array('lib'=>__('Date JJ/MM/AAAA', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[date]'),
                      array('lib'=>__('Lieu', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[place]'),
                      array('lib'=>__('Heure', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[time]'),
                      array('lib'=>__('Lien', $this->plugin_texdomain),
                            'name'=>'meetings_'.$active_tab.'[link]')
                                    )
                    );
          
         
            
          /////// displays tabs
          ?>
            <div class="wrap">
                <div class="icon32" id="icon-options-general"><br /></div>
                <h2>
                    <?php //_e('WpCoop v'.$this->version(), $this->plugin_textdomain) ?>
                </h2>
                <h2 class="nav-tab-wrapper">
                <?php
                if (!empty($tabs)) {
                  foreach ($tabs as $tab) {
                    $addclass= ($tab['slug']==$active_tab)? 'nav-tab-active' : '';
                    ?>
                    <a href="?page=<?php echo 'meetings'; ?>&tab=<?php echo $tab['slug']; ?>" class="nav-tab <?php echo $addclass; ?>"><?php echo $tab['caption']; ?> </a>
                    <?php
                  }
                }
                ?>
                </h2>
            </div>
          <?php    
          switch ($active_tab) {
                 case 'ca':
                  // Manage board of directors
                  echo '<h3>'.__('Board of directors', $this->plugin_textdomain).'</h3>';
                  
                  // check wpnonce
                  
                  if (isset($_REQUEST[$this->plugin_prefix.'end'])) unset($_REQUEST);
                  if (isset($_REQUEST[$this->plugin_prefix.'meetings_year']) && $_REQUEST[$this->plugin_prefix.'meetings_year']=='new') {
                    // new ca  
                    $this->display_meeting_form($args);  
                      
                      
                      
                  } elseif (isset($_REQUEST[$this->plugin_prefix.'meetings_year'])) {
                    // list ca for given year
                    $year=sprintf('%04d', intval($_REQUEST[$this->plugin_prefix.'meetings_year']));
                    $meetings= get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$year);
                    foreach($meetings as $date){
                       $meeting=get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$date); 
                       print_tab($meeting); 
                        
                    }

                      
                  } elseif (isset($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]['date'])) {
                      
                    $args['items']=intval($_REQUEST[$this->plugin_prefix.'meetings_items']);  
                      
                    //format date to check it  
                    $ar_date=explode('/',$_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]['date']);
                    if (count($ar_date)!=3 || !checkdate($ar_date[1], $ar_date[0], $ar_date[2])) {
                        // date Nok 
                        
	                   $this->print_notices('notice notice-error', __('Incorrect Date', $this->plugin_textdomain));
                        
                    } else {
                        // date ok
                    
                        $fdate=sprintf('%04d%02d%02d',$ar_date[2],$ar_date[1],$ar_date[0]);

                        if (empty(end($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]))) {

                            while (empty(end($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]))) {
                                array_pop($_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]);
                            }
                            
                            update_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.$fdate, $_REQUEST[$this->plugin_prefix.'meetings_'.$active_tab]);
                            //@TODO lock tables ?    
                            $dates=get_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.substr($fdate,0,4));
                            if (!in_array($dates,$fdate)) $meetings[]=$fdate;
                            update_option($this->plugin_prefix.'meetings_'.$active_tab.'_'.substr($fdate,0,4), $meetings);
 	                        $this->print_notices('notice notice-success', __('Meeting Created/Updated', $this->plugin_textdomain));
                         
                        }  else {
                          //add lines
                          $args['items']=intval($_REQUEST[$this->plugin_prefix.'meetings_items'])+5;
                        }
                    
                    }
                    //re-display form with values  
                                       
                    $this->display_meeting_form($args);
 
                  } else {
                    // action is not set, display select only
                    $this->display_meeting_form(array('tab'=>'ca','items'=>0, 'fields'=>array()));
                  
                  }
                  

                  break;
                 case 'ago':
                  break;
                 case 'agoe':
                  break;
                 case 'age':
                  break;
          } 
        }
      
        public function display_meeting_form($args) {
           ?>
           <form method="post" action="<?php echo admin_url('admin.php?page=meetings&tab='.$args['tab']) ?>" >
            <?php settings_fields($this->plugin_prefix.'meetings_'.$args['tab']); ?>
            <h3><?php _e('', $this->plugin_textdomain) ?></h3>
            <div>
             <table class="form-table">
             <?php
             if (empty($args['fields'])) {
                  $firstyear='2017'; // @TODO find it in parameters
                  $thisyear=date('Y');
                  ?>
                  <select name="<?php echo $this->plugin_prefix.'meetings_year' ?>"> 
                  <?php
                  echo '<option value="new">'.__('Add a meeting', $this->plugin_textdomain).'</option>';
                  for ($year=$thisyear; $year<$thisyear+2; $year++ ) {
                    echo '<option value="'.$year.'">'.$year.'</option>';  
                  }
                  ?>
                  </select>
                  <?php    
             }
             
             $args['values']= array($_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['date'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['place'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['time'],
                                    $_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['link']
                                   ); 
                                   
             for($i=1;$i<$args['items']+1;$i++) {
                $args['fields'][]=array('lib'=>sprintf(__('Résolution %d', $this->plugin_textdomain), $i), 'name'=>'meetings_'.$args['tab'].'[item'.$i.']');   
                $args['values'][]=$_REQUEST[$this->plugin_prefix.'meetings_'.$args['tab']]['item'.$i];   
             }
             
            foreach($args['fields'] as $k=>$field) {
              echo'
              <tr>
               <td>'.$field['lib'].'</td>
               <td><input type="text" name="'.$this->plugin_prefix.$field['name'].'" value="'.esc_attr($args['values'][$k]).'" /></td>
              </tr>
              ';  
             }           
           
             echo'<input type="hidden" name="'.$this->plugin_prefix.'meetings_items" value="'.esc_attr($args['items']).'" /></td>';        
             ?>
             </table>
             <p class="submit">
              <input type="submit" class="button-primary" value="<?php _e('VALIDATE', $this->plugin_textdomain) ?>" />
             </p>
             <?php if($args['items']!=0) : ?>    
             <p class="submit">
              <input type="submit" name="<?php echo $this->plugin_prefix.'end' ?>" class="button-primary" value="<?php _e('RETURN', $this->plugin_textdomain) ?>" />
             </p>
             <?php endif ?>                    
            </div>
           </form>
           <?php           
        }
            
        public function print_notices($classes, $message) {
           printf( '<div class="%1$s"><p>%2$s</p></div>', esc_attr( $classes ), esc_html( $message ) );   
        }
      
        public function admin_main_page() {
            
            // user can ? wpnonce ?  
           
            if (isset($_REQUEST['noheader']) && $_REQUEST['noheader']=='true') {
             // form activated, no header send, issue document 
             $ID=0;  // ? all users
             $list=0;
             $att=0;
             $title="";    
             if (!isset($_POST[$this->plugin_prefix.'get_all_user_docs'])) {
              $len=strlen($this->plugin_prefix.'get_user_docs');     
              foreach($_POST as $k=>$v) { 
                  if (substr($k, 0, $len)==$this->plugin_prefix.'get_user_docs') {
                   $ID=intval(substr($k, $len));
                   break;
                  }
                  if ($k==$this->plugin_prefix.'get_subs_list') {
                    $list=1;
                    $title= (isset($_POST[$this->plugin_prefix.'list_sheet_title']))?  
                             $_POST[$this->plugin_prefix.'list_sheet_title'] : __('Subscribers list', $this->plugin_textdomain); 
                  }
                  if ($k==$this->plugin_prefix.'get_att_sheet') {
                    $att=1; 
                    $title= (isset($_POST[$this->plugin_prefix.'att_sheet_title']))?  
                             $_POST[$this->plugin_prefix.'att_sheet_title'] : __('Attendance sheet', $this->plugin_textdomain); 
                  }
                  if ($k==$this->plugin_prefix.'get_subs_oreg') {
                      $list=2;
                  }
                  if ($k==$this->plugin_prefix.'get_subs2val_list') {
                      $list=3; 
                  }
                  if ($k==$this->plugin_prefix.'att_sheet_ne') {
                    $ne= (isset($_POST[$this->plugin_prefix.'att_sheet_ne']))?  
                             intval($_POST[$this->plugin_prefix.'att_sheet_ne']) : 0; 
                  }
               }   
             }
             
             $this->issue_documents($ID, $list, $att, $title, $ne); 
                
             // no footer etc...    
             exit();   
                
            } else {
                
             $this->display_page();   
            
            }
        }
      
        public function admin_add_subpage1() {
            // here only if capability ok
            //print_tab($_POST);          
            echo '<h3>'.__("Manage Coop members", $this->plugin_textdomain ).'</h3>';
            echo '<h4>'.__("Use Help button on the right", $this->plugin_textdomain ).'</h4>';
            //<div class="error"><p>Cette fonction n\'est pas encore testée à fond!!, voir l\'administrateur</p></div>';
            
            $user_data_fields=$this->get_user_data_fields();
            //print_tab($user_data_fields);
                
            $added_profile_fields=$this->get_added_profile_fields();
            //print_tab($added_profile_fields);
            
            $added_profile_category_fields=$this->get_added_profile_category_fields();
            //print_tab($added_profile_category_fields); 
            
            if ( isset($_POST[$this->plugin_prefix.'wpnonce']) && 
                    wp_verify_nonce( $_POST[$this->plugin_prefix.'wpnonce'],'wpcoopsubpage1')) {
                
                $user_data=array();  
                // choose or record any case you may have userid
                if (isset($_POST[$this->plugin_prefix.'user_id']) && $_POST[$this->plugin_prefix.'user_id']!=-1) {
                 // if != -1 edit user with userid    
                 $user_data['ID']= (int) $_POST[$this->plugin_prefix.'user_id'];
                  
                 // if user is not in this blog/site, put it with subscriber role 
                 $blogid=get_current_blog_id();  
                 if (!is_user_member_of_blog( $user_data['ID'], $blogid)) add_user_to_blog( $blogid, $user_data['ID'], 'subscriber' ); 
                     
                     
                 // fill   user_data with old values if any   
                 $userObj = get_userdata( $user_data['ID'] ); 

                 if ($userObj === false) {
                    $class = 'notice notice-error';
                    $message = __( 'User ID unknown: ', $this->plugin_textdomain).$user_data['ID'];
                    printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );                        
                    unset($user_data['ID']); 
                 } else {
                    //print_tab($userObj); 
                    $user_data['roles']= $userObj->roles; 
                    $meta=get_user_meta($user_data['ID']);

                    foreach($user_data_fields as $k=>$field) { 
                        $user_data[$k]= (isset($meta[$this->plugin_prefix.$k]))? $meta[$this->plugin_prefix.$k][0] : '';
                        $user_data[$k]= (isset($userObj->{$k}))? $userObj->{$k} : '';
                    } 
                    foreach($added_profile_fields as $k=>$l) {
                        $user_data[$k]= (isset($meta[$k]))? $meta[$k][0] : '';
                    }
                    foreach($added_profile_category_fields as $k=>$f) {
                        $user_data[$f['name']]= (isset($meta[$f['name']]))? $meta[$f['name']][0] : '';
                    }
                     
                    $user_data['cap'] =($userObj->has_cap($this->plugin_capability))? 1 : 0; 

                 }
                    
                } // userid exists select or modifyuser  
                //print_tab($user_data);
                
                if (isset($_POST[$this->plugin_prefix.'record'])) { 
                   // set user_data field not in $user_data_fields    
                   $user_id = (isset($user_data['ID']))? $user_data['ID'] : -1;                         // edit current user or create new one 
                   $role = (isset($user_data['roles']))? $user_data['roles'][0] : 'subscriber';         // keep existant role
                   $cap= $user_data['cap']; // keep capability or not   
                   $user_registered = (isset($user_data['user_registered']))? $user_data['user_registered'] : date('Y-m-d H:i:s'); // keep old registered date 

                   $user_data=array(); 
                   if ($user_id!=-1) $user_data['ID']=$user_id;  // if ID==-1 don't set $user_data['ID']
                   foreach($user_data_fields as $k=>$f) { 
                        $user_data[$k]= (isset($_POST[$this->plugin_prefix.$f['name']]))? $_POST[$this->plugin_prefix.$f['name']] : '';
                   } 
                   $user_data['role']=$role; 
                   $user_data['cap']=$cap; 
                   $user_data['user_registered']=$user_registered; 
                   $user_data['display_name']='';    
                   $user_data['display_name'].= (isset($_POST[$this->plugin_prefix.'pre_first_name']))? $_POST[$this->plugin_prefix.'pre_first_name'] : '';
                   $user_data['display_name'].= ($user_data['display_name']=='')? 
                       ((isset($_POST[$this->plugin_prefix.'pre_last_name']))? $_POST[$this->plugin_prefix.'pre_last_name'] : '') : ' '.((isset($_POST[$this->plugin_prefix.'pre_last_name']))? $_POST[$this->plugin_prefix.'pre_last_name'] : ''); 
                    
                   //print_tab($user_data);
                    
                   // insert or update user depending on ID set or not

                    $user_id = wp_insert_user( $user_data ) ;

                    if ( ! is_wp_error( $user_id ) ) {
                        // on success add meta data for user

                        $class = 'notice notice-success';
                        $message = __('Enregistrement OK', $this->plugin_textdomain);
                        printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
                        
                        // success, we will have to update meta
                        $insert_success=true;
                        
                        // set user_data['ID'] for form (edit instead of create) 
                        $user_data['ID']=$user_id;
                   
                    } else {
                        //$user_id is wp_error object
                        foreach ($user_id->errors as $t=>$e) {
                            $class = 'notice notice-error';
                           $message = __( $e[0], $this->plugin_textdomain);
                           printf( '<div class="%1$s"><p>%2$s</p></div>', $class, $message );
                        }
                        
                        // error, we won't have to update meta
                        $insert_success=false;
                        
                    } // user creation/edit failed
                    
                    // fill added fields for form
                           
                    foreach($added_profile_fields as $k=>$label) {
                        if (isset($_POST[$k])) {
                            $user_data[$k] = $_POST[$k];         //sanitized in update_user_meta
                        } else {
                            $user_data[$k] = ''; 
                        }
                        // update metaif success
                        if ($insert_success) update_user_meta( $user_id, $k, $user_data[$k]);
                    } 
                    //print_tab($user_added_fields);

                    // fill added profile category fields for form

                    foreach($added_profile_category_fields as $field) {
                        if (isset($_POST[$field['name']]))  {
                            $user_data[$field['name']]= $_POST[$field['name']];  //sanitized in update_user_meta
                        } else {
                            $user_data[$field['name']]=''; 
                        }
                        if ($insert_success) update_user_meta( $user_id, $field['name'], $user_data[$field['name']]);  
                    }
                    
                    if ($insert_success) {
                    // grant or revoke plugin_capability to user
                        
                        $user = new WP_User( $user_id );  // on success, insert gave user_id
                        
                        if (isset($_POST[$this->plugin_prefix.$this->plugin_capability])) {
                          $user_data['cap']=1; 
                          $user->add_cap( $this->plugin_capability );  
                        } else {
                          $user_data['cap']=0;   
                          $user->remove_cap( $this->plugin_capability );  
                        }
                    
                    } // update capability 
                } // record
                
                if (isset($_POST[$this->plugin_prefix.'search'])) {
                    
                 $found=false;
                 $blogid= get_current_blog_id();  
                 $sites=get_sites(array('site__in'=>$blogid));
                 $users=get_users(array('blog_id'=>$blogid));
                    
                 $siteuserids = $this->display_found_users($sites[0], $users, $_POST[$this->plugin_prefix.'search'], __('Edit', $this->plugin_textdomain) );
                    
                 if (is_multisite()) {   
                     $sites=get_sites(array('site__not_in'=>$blogid));
                     foreach ($sites as $site) {  
                        $users=get_users(array('blog_id'=>$site->blog_id, 'exclude'=>$siteuserids));
                         
                        $this->display_found_users($site, $users, $_POST[$this->plugin_prefix.'search'], __('Add and Edit', $this->plugin_textdomain)); 
                     }
                 }
                    
                } else {
                
                
                // user form
                ?>
                    <form action="<?php echo admin_url('admin.php?page=add1') ?>" method="post" >
                    <?php echo wp_nonce_field( 'wpcoopsubpage1', $this->plugin_prefix.'wpnonce', true, false ); 
                    echo '<table>';
                    if (isset($user_data['ID']) && $user_data['ID']!=-1) {   
                     echo '<input type="hidden" name="'.$this->plugin_prefix.'user_id'.'" value="'.$user_data['ID'].'"   />';   
                    }
                    foreach($user_data_fields as $k=>$field){   
                     echo '
                     <tr><td>'.$field['label'].'</td><td><input name="'.$this->plugin_prefix.$field['name'].'" value="'.esc_attr($user_data[$k]).'"   /></td><td><span>'.$field['desc'].'</span></td></tr>';  
                    } 

                    foreach($added_profile_fields as $k=>$field){
                     echo '
                     <tr><td>'.$field.'</td><td><input name="'.$k.'" value="'.esc_attr($user_data[$k]).'" /></td></tr>';  
                    }    

                    foreach($added_profile_category_fields as $field){
                     echo '
                     <tr><td>'.$field['label'].'</td><td><input name="'.$field['name'].'"  value="'.esc_attr($user_data[$field['name']]).'" /></td><td>'.$field['desc'].'</td></tr>'; 
                    }

                    $chk = ($user_data['cap']==1)? 'checked="checked"' : '' ;

                    echo '
                     <tr><td>'.(__('Cooperative site manager')).'</td>
                         <td><input type="checkbox" name="'.$this->plugin_prefix.$this->plugin_capability.'" '.$chk.' /></td>
                         <td>'.(__('Check if subscriber can manage Cooperative site',$this->plugin_textdomain)).'</td>
                     </tr>
                    </table>'; 
                    submit_button( __( 'Record' ), 'primary', $this->plugin_prefix.'record', true); 
                
                }
                
            } // post && wp_nonce
            
            if(!isset($_POST[$this->plugin_prefix.'choose']) && !isset($_POST[$this->plugin_prefix.'record']) && !isset($_POST[$this->plugin_prefix.'search'])) {    

                ?>

                <form action="<?php echo admin_url('admin.php?page=add1') ?>" method="post" >
                <?php echo wp_nonce_field( 'wpcoopsubpage1', $this->plugin_prefix.'wpnonce', true, false ); 
                echo '<table>
                <tr><th>'.__('Find User/Member', $this->plugin_textdomain).'</th></tr>
                <tr><td><input type="text" name="'.$this->plugin_prefix.'search" value="'.esc_attr($sstr).'"></td></tr>
                <tr><td>';
                submit_button( __( 'Find', $this->plugin_textdomain), 'primary', $this->plugin_prefix.'find', true); 
                echo '</td></tr>
                </table>
                </form>';

                // no button pressed yet, display dropdown box in form
                ?>
                <form action="<?php echo admin_url('admin.php?page=add1') ?>" method="post" >
                <?php echo wp_nonce_field( 'wpcoopsubpage1', $this->plugin_prefix.'wpnonce', true, true ); 
                echo '<table>
                <tr><th>'.__('Create or select member', $this->plugin_textdomain).'</th></tr><tr><td>';
                
                // display select box of all users beginnig by add new subscriber message
                $this->dropdown_users( array( 'name'=>$this->plugin_prefix."user_id",
                                                      'show_option_none' =>__('Create new member',$this->plugin_textdomain),
                                                      'selected'=>$userid
                                             )                              
                                      );
                echo '</td></tr><tr><td>';
                submit_button( __( 'Choose "Create" or Select User to edit',$this->plugin_textdomain ), 'primary', $this->plugin_prefix.'choose', true);
                echo '
                    </td></tr></table    
                </form>';
            } // no buttons pressed ?
        }
       
        public function display_found_users($site, $users, $sstr, $button_lib) {
         $siteusers=array(); 
         if (count($users)>0) {
            $found=false;
            $str=' 
            <table border="1"><caption>'.sprintf(__("Found on site %s",$this->plugin_textdomain), $site->domain.$site->path).'</caption>
                <tr><th>'.__('Login',$this->plugin_textdomain).'</th>
                    <th>'.__('Nice Name',$this->plugin_textdomain).'</th>
                    <th>'.__('Display Name',$this->plugin_textdomain).'</th>
                    <th>'.__('Company',$this->plugin_textdomain).'</th>
                    <th>'.__('Email',$this->plugin_textdomain).'</th>
                    <th>'.__('Action',$this->plugin_textdomain).'</th>
                </tr>
            <form action="'.admin_url('admin.php?page=add1').'" method="post" >
            '.wp_nonce_field( 'wpcoopsubpage1', $this->plugin_prefix.'wpnonce', true, false ); 
            foreach ($users as $user) {
             if ($this->find_user($user, $sstr) || empty($sstr)) {
                $found=true; 
                $siteusers[]=$user->ID;
                $str.='<input type="hidden" name="'.$this->plugin_prefix.'user_id" value="'.$user->ID.'" />   
                <tr><td>'.esc_html($user->user_login).'</td><td>'.esc_html($user->nice_name).'</td>
                    <td>'.esc_html($user->display_name).'</td><td>'.esc_html($user->company).'</td>
                    <td>'.esc_html($user->user_email).'</td><td>'.
                get_submit_button($button_lib, 'primary', $this->plugin_prefix.'choose', false).'</td></tr>';
             }
            }
            $str.=' 
            </form></table>';
            if ($found) echo $str; 
         }//count>0
         return $siteusers;    
        }
      
      
        public function find_user($user, $sstr) {
            $sstr=remove_accents(strtolower($sstr));
            $user->company = get_user_meta($user->ID, $this->plugin_prefix.'company', true);
            //print_tab($user);
            if (strpos(remove_accents(strtolower($user->nice_name)), $sstr)!==false || 
                strpos(remove_accents(strtolower($user->display_name)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->user_email)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->user_login)), $sstr)!==false ||
                strpos(remove_accents(strtolower($user->company)), $sstr)!==false
                ) {  
                    return true;
                } 
            return false;
        }
      
        public function get_share_price() {
           $options_shares = get_option($this->plugin_prefix.'options_shares');
           return apply_filters($this->plugin_prefix.'get_share_price', $options_shares['price']);    
         }
      
        public function admin_add_actions() {   
           if ( ( @include 'actions.php' ) === FALSE ) _e('actions.php file not found', $this->plugin_textdomain);     
        }
      
        public function actions_help() {
            $profile_help = '<p>' . __('Actions',$this->plugin_textdomain) . '</p>' .
                            '<p>' . __('Select subscriptions on which apply action',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Permits action on multiple subscription',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Usage is to validate new subscriptions',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Or to validate new shareholders after a General Assembly',$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab( array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $profile_help,
            ) );

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );
           
        }
    
   
        public function dropdown_users($options) {
                // defaults args
                $defaults=array('name'=>'dropdown', 'show_option_none'=>'', 'selected'=>0);
                $options=wp_parse_args($options,$defaults);
                $ops = $this->get_ordered_users('all');
                //print_tab($ops);
                echo '<select name="'.$options['name'].'">';
                if ($options['show_option_none']!='') echo '<option value="-1">'.$options['show_option_none'].'</option>';
                foreach ($ops as $id=>$user) {
                    $sel = ($options['selected']==$id)? 'selected="selected"' : '' ;
                    if (empty($user[$this->plugin_prefix.'company'])) {
                     echo '<option value="'.$id.'" '.$sel.'>'.$user['last_name'].' '.$user['first_name'].'</option>';
                    } else {
                     echo '<option value="'.$id.'" '.$sel.'>'.$user[$this->plugin_prefix.'company'].' ('.$user['last_name'].' '.$user['first_name'].')</option>';
                    }
                }
                echo '</select>';
        }

                
        public function admin_add_subpage2() {  
          if ( ( @include 'subscriptions.php' )=== FALSE ) _e('subscriptions.php file not found', $this->plugin_textdomain);  
        }
      
        // display subscription form to create operation or edit step
        // if admin, access to more functions are granted
        // $step: userid_operation_step
        public function display_subscription_form($userid, $newstatus, $newqty, $newdate, $step, $submit ) {
            //echo "$userid, $newstatus, $newqty, $newdate, $step, $submit";
            $ar_step=$this->get_step_array($step);
            //print_tab($ar_step);
            ?>
            <form action="<?php echo admin_url('admin.php?page=add2') ?>" method="post" >
            <?php echo wp_nonce_field( 'wpcoopsubpage2', $this->plugin_prefix.'wpnonce', true, false ); ?>
            <input type="hidden" name="<?php echo esc_attr($this->plugin_prefix.'userid'); ?>" value="<?php echo esc_attr($userid) ?>" />
            <input type="hidden" name="<?php echo esc_attr($this->plugin_prefix.'step'); ?>" value="<?php echo esc_attr($step) ?>" />
            <label><?php echo ($submit=='submit')? __('Nouvelle Opération de Souscription', $this->plugin_textdomain) : __('Modification souscription', $this->plugin_textdomain) ; ?> <br />    
             <?php   
           if ($submit!='submit') { 
            ?>   
                <label><?php _e("Numero d'opération.", $this->plugin_textdomain); ?><br>
                    <input name="<?php echo esc_attr($this->plugin_prefix.'operation'); ?>" value="<?php echo esc_attr($ar_step[1]) ?>" /><br />
                </label>
            <?php    
            }
            
            
            ?>
             <select name="<?php echo esc_attr($this->plugin_prefix.'newstatus'); ?>" >
                <option value="none"    <?php echo ($newstatus=="none" || empty($newstatus))? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['none'] ?></option>
                <option value="subsnok" <?php echo ($newstatus=="subsnok")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['subsnok'] ?></option>
                <option value="subsok"  <?php echo ($newstatus=="subsok")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['subsok'] ?></option>
          <!--      <option value="pending" <?php echo ($newstatus=="pending")? 'selected="selected"' : ''; ?> ><?php echo $this->possible_statuses['pending'] ?></option> -->
             </select>
           </label>    
            <?php
            $date = (strlen($newdate)==8)? substr($newdate,0,2).'/'.substr($newdate,2,2).'/'.substr($newdate,4,4) : '';    
                
            ?>
            <br/>    
            <label><?php _e('Montant', $this->plugin_textdomain); ?><br>
                <input name="<?php echo esc_attr($this->plugin_prefix.'newqty'); ?>" value="<?php echo esc_attr($newqty) ?>" />
            </label>
            <br/>
            <label><?php _e('Date (jj/mm/aaaa)', $this->plugin_textdomain); ?><br>    
            <input name="<?php echo esc_attr($this->plugin_prefix.'newdate'); ?>" value="<?php echo esc_attr($date) ?>" />
            </label>
            <br />
            <label><?php _e('Note', $this->plugin_textdomain); ?><br>    
            <input name="<?php echo esc_attr($this->plugin_prefix.'newnote'); ?>" value="<?php echo esc_attr($note) ?>" />
            </label>
            <br />
            <input type="submit" name="<?php echo esc_attr($this->plugin_prefix.$submit); ?>" value="OK" />
            </form>
            <?php   
        }
        // convert userid_operation_step -> array(int userid, int operation, int step)
        public function get_step_array($step) {
          $ar_step=explode('_',$step);
          if (count($ar_step)!=3) return array(); else return array(intval($ar_step[0]), intval($ar_step[1]), intval($ar_step[2]));  
        }
      
        public function get_action_keys() {
            $ak=array();
            foreach($this->workflow as $wf) {
                foreach($wf as $a) {
                  $ak[]=$a['action'];  
                }
            }
            return array_unique($ak);
        }
      
        public function page_help() {
          $overview_help = '<p>' . __('Gestion de la coopérative',$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('Cette page donne la liste des souscripteurs, et permet de générer les documents associés en pdf ',$this->plugin_textdomain) . '</p>'.
                           '<p>' . __("Terminologie: un souscripteur a souscrit des parts qui peuvent ne pas être encore validées, il n'est donc pas encore formellement sociétaire",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Le tableau récapitulatif donne les montants souscrits et les parts validées ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Le registre officiel ne liste que les sociétaires (parts validées)",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("La validation des parts peut se faire, suivant les statuts et les cas, par une AG, un CA ou le président",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Le document obtenu par les boutons de droite sont les mêmes que ceux qui peuvent être obtenus par les soucripteurs dans la page "mon compte"',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Attention, générer les documents pour tous les souscripteurs peut donner lieu à une grosse charges du serveurs, si les souscripteurs sont très nombreux',$this->plugin_textdomain) . '</p>'.                            
                            '<p>' . __('Pour la liste des souscripteurs et la feuille de présence, on peut donner un titre (par exemple liste des souscripteurs à telle date, AG de telle date)',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Pour la feuille de présence, on peut ajouter des pages vides (avec les cases), si des personnes non inscrites peuvent se présenter',$this->plugin_textdomain) . '</p>';
            
            $search_help = '<p>' . __("Recherche d'utilisateur",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("La recherche se fait sur l'ensemble des sites de la plateforme (site principal, sociétaire, intranet,etc)" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Il suffit de tapper quelques lettres du login, nom ou prénom, adresse mél et de cliquer sur "Trouver"' ,$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Les résultats du site "sociétaires" sont présentés en premier, on peut directement modifier les données de ces comptes en cliquant surle bouton "Modifier" à droite',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Les résultats des autres sites sont présentés ensuite; pour ajouter l'utilisateur comme sociétaire et le modifier, il suffit d'ajouter sur le bouton \"Ajouter et modifier\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur sera validé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>';
            
            $edit_help   = '<p>' . __("Création/modification d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('cocher la case si on veut que le nouveau souscripteur puisse gérer la coopérative',$this->plugin_textdomain) . '</p>';
            
            $delete_help = '<p>' . __("Suppression d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("Pas possible dans Wpcoop, demander à l'administrateur du site" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Mais on peut supprimer toutes les souscriptions du sociétaire' ,$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $overview_help,
                ));
            /*
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'search',
	           'title'   => __('Search'),
	           'content' => $search_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'edit',
	           'title'   => __('Edit member'),
	           'content' => $edit_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'delete',
	           'title'   => __('Delete member'),
	           'content' => $delete_help,
                ));
            */    
            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="http://pep2a.fr/societaires/wp-content/uploads/sites/2/2017/06/statuts_scic_pep2a.pdf" target="_blank">Statuts PEP2A</a>') . '</p>' 
            );
     
            
        }
      
        public function subpage1_help() {
            $overview_help = '<p>' . __('Ajout de sociétaires',$this->plugin_textdomain) . '</p>' .
                            '<p>' . __('Un sociétaire doit avoir un compte validé sur le site "sociétaires" ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Attention, un sociétaire peut avoir un compte sur un autre site du réseau, il faut le valider sur le site "sociétaire" ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Il faut éviter les doublons, donc rechercher si le sociétaire est défini comme utilisateur sur un autre site (principal, intranet, extranet, boutique ...) " ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Pour cela, commencer par rechercher le sociétaire; s'il est trouvé sur le site sociétaire, il est possible de le modifier directement en cliquant sur le bouton de droite",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur ser avalidé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Sinon sélectionner Ajouter et valider ',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Il faut ajouter le souscripteur avant d\'ajouter une souscription',$this->plugin_textdomain) . '</p>';
            
            $search_help = '<p>' . __("Recherche d'utilisateur",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("La recherche se fait sur l'ensemble des sites de la plateforme (site principal, sociétaire, intranet,etc)" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Il suffit de tapper quelques lettres du login, nom ou prénom, adresse mél et de cliquer sur "Trouver"' ,$this->plugin_textdomain) . '</p>'.
                            '<p>' . __('Les résultats du site "sociétaires" sont présentés en premier, on peut directement modifier les données de ces comptes en cliquant surle bouton "Modifier" à droite',$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("Les résultats des autres sites sont présentés ensuite; pour ajouter l'utilisateur comme sociétaire et le modifier, il suffit d'ajouter sur le bouton \"Ajouter et modifier\"",$this->plugin_textdomain) . '</p>'.
                            '<p>' . __("S'il est trouvé sur un autre site, cliquer sur le bouton \"Ajouter et modifier\", le compte utilisateur sera validé sur le site \"sociétaire\"",$this->plugin_textdomain) . '</p>';
            
            $edit_help   = '<p>' . __("Création/modification d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __('cocher la case si on veut que le nouveau souscripteur puisse gérer la coopérative',$this->plugin_textdomain) . '</p>';
            
            $delete_help = '<p>' . __("Suppression d'un sociétaire",$this->plugin_textdomain) . '</p>' .
                           '<p>' . __("Pas possible dans Wpcoop, demander à l'administrateur du site" ,$this->plugin_textdomain) . '</p>'.
                           '<p>' . __('Mais on peut supprimer toutes les souscriptions du sociétaire' ,$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $overview_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'search',
	           'title'   => __('Search'),
	           'content' => $search_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'edit',
	           'title'   => __('Edit member'),
	           'content' => $edit_help,
                ));
            get_current_screen()->add_help_tab(
            array(
	           'id'      => 'delete',
	           'title'   => __('Delete member'),
	           'content' => $delete_help,
                ));

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );
        }
      
        public function subpage2_help() {
            $profile_help = '<p>' . __('Ajout de souscriptions',$this->plugin_textdomain) . '</p>' .
                      '<p>' . __('Il faut ajouter le souscripteur avant d\'ajouter la souscription',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Les souscriptions passent par plusieurs étapes:',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Dossier de souscription reçu (complet ou incomplet - manque de pièces ou paiement pas encaissé ou délai de rétraction pas passé) ',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("On ne peut saisir que des souscriptions (complètes ou incomplètes), les étapes suivantes se font à l'aide des boutons",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('Souscription en attente de validation: le dossier est transmis pour validation en CA ou AG ou président',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Souscription effective: validation faite, le souscripteur devient sociétaire s'il ne l'était déjà et obtient X parts sociales",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Montant est à entrer en euros sans l'unités (nombre entier multiple du montant de la part)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __('La date est à entrer: j=jour, m=mois, a=année, par exemple 21/12/2016 pour le 21 décembre 2016',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Attention, le format de la date est vérifié mais pas la chronologie",$this->plugin_textdomain) . '</p>';

            $actions_help = '<p>' . __('Actions',$this->plugin_textdomain) . '</p>' .
                      '<p>' . __('Une fois la souscription saisie, les étapes suivantes sont générées en cliquant sur les boutons "Actions"',$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Les boutons sont générés en fonction des opérations possibles suivant l'état actuel de la souscription",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("On peut supprimer les souscriptions tant qu'elles ne sont pas validées en parts",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Subs. Ok fait passer de dossier incomplet à complet",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Att. Val fait passer de dossier complet à en attente de validation (transmis à l'instance décisionnelle)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Il faut entrer la date correspondant à la décision de l'action (CA, AG etc...)",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("Attention, le format de la date esst vérifié mais pas la chronologie",$this->plugin_textdomain) . '</p>'.
                      '<p>' . __("En cas d'erreur de saisie, seul l'administrateur du site peut modifier les données",$this->plugin_textdomain) . '</p>';

            get_current_screen()->add_help_tab( array(
	           'id'      => 'overview',
	           'title'   => __('Overview'),
	           'content' => $profile_help,
            ) );
            
            get_current_screen()->add_help_tab( array(
	           'id'      => 'actions',
	           'title'   => __('Actions'),
	           'content' => $actions_help,
            ) );

            get_current_screen()->set_help_sidebar(
                '<p><strong>' . __('For more information:') . '</strong></p>' .
                '<p>' . __('<a href="https://codex.wordpress.org/Users_Your_Profile_Screen" target="_blank">Documentation on User Profiles</a>') . '</p>' .
                '<p>' . __('<a href="https://wordpress.org/support/" target="_blank">Support Forums</a>') . '</p>'
            );
        }
      
         public function display_page() {

            // get subscribers, that is, users with a status
            echo '<h3>'.__('Display all subscribers', $this->plugin_textdomain).'</h3>';
            echo '<canvas id="odoCanvas1" height="50" width="300">No canvas support!</canvas>';
            echo '<span> €, par <span>'; 
            echo '<canvas id="odoCanvas2" height="50" width="300">No canvas support!</canvas>';
            echo '<span> Sociétaires<span>'; 
            $ops=$this->get_ordered_users( 'all', 'subs' );
  
            if (!empty($ops)) {
                ?>
                <form name="post" action="<?php echo admin_url('admin.php?page=wpcoop&noheader=true'); ?>" method="post" id="post">
                    <table>
                        <tr><th><?php _e('ID', $this->plugin_textdomain); ?></th><th><?php _e('Login', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Nom Usuel', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Raison sociale', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Amount', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Validated Shares', $this->plugin_textdomain); ?></th>
                            <th><?php _e('Documents', $this->plugin_textdomain); ?></th>
                        </tr>
                <?php
            $t=0;  // total amount
            $ts=0; // total number of shares    
            $n=0;  // number of subscribers
            foreach($ops as $id=>$user) {
                 //print_tab($user);
                 
                 //$meta= get_user_meta($id, $this->plugin_usersubs_meta, true); 
                 if (empty($ops[$id]['usersubs'])) continue; 
                 $n++; 
                 $s=0; // # shares
                 $v=0; // value                 
                 foreach ($user['usersubs'] as $o=>$opers) {
                    foreach($opers as $i=>$step) {   
                        //$date=$step['d'];         
                        //$fdate=substr($date,0,2).'/'.substr($date,2,2).'/'.substr($date,4,4);  
                        if (strpos($step['s'],'share')!==false) {   
                        //    $unit='Parts';
                            $val=$step['q']/$this->get_share_price();
                            $s+=$val;    
                        } else {
                        //    $unit='Euros';
                            $val=$step['q'];
                            if ($i==0) $v+=$step['q'];    
                        }
                    }
                 }
                 echo '<tr>
                 <td>'.$id.'</td>
                 <td style="text-align: left;">'.$user['user_login'].'</td>
                 <td>'.$user['last_name'].' '.$user['first_name'].'</td>
                 <td>'.$user[$this->plugin_prefix.'company'].'</td>
                 <td style="text-align: right;">'.$v.'</td>
                 <td style="text-align: right;">'.$s.'</td>
                 <td><input type="submit" name ="'.$this->plugin_prefix.'get_user_docs'.$id.'" value="'.__('Get User Docs', $this->plugin_textdomain).'" /></td></tr>';    
                 $t+=$v;
                 $ts+=$s;
                    
                }
                
                
                
                
                echo '<tr>
                <td colspan="2">'.__('Number of subscribers:', $this->plugin_textdomain ).'</td>
                <td>'.$n.'</td>
                <td>'.__('Total amounts', $this->plugin_textdomain).'</td>
                <td style="text-align: right;">'.$t.'</td>
                <td style="text-align: right;">'.$ts.'</td>
                <td><input type="submit" name ="'.$this->plugin_prefix.'get_all_user_docs'.'" value="'.__('Get All Users Docs', $this->plugin_textdomain).'" /></td></tr>'; 
                
                echo '<tr>
                    <td >'.__('Official register of shareholders', $this->plugin_textdomain).'
                    <td colspan="3"></td>
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_oreg'.'" value="'.__('Get Official Register', $this->plugin_textdomain).'" /></td></tr>'; 
                
                echo '<tr>
                    <td colspan="4">'.__('List of subscripions to validate', $this->plugin_textdomain).'
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs2val_list'.'" value="'.__('Get list of subscripions to validate', $this->plugin_textdomain).'" /></td></tr>'; 

                echo '<tr>
                    <td colspan="4">'.__('Title', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'list_sheet_title'.'" value="" />
                    </td><td><input type="submit" name ="'.$this->plugin_prefix.'get_subs_list'.'" value="'.__('Get subscribers list', $this->plugin_textdomain).'" /></td></tr>'; 
                
                echo '<tr>
                    <td colspan="4">'.__('Title', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'att_sheet_title'.'" value="" />'
                    .__('Empty pages', $this->plugin_textdomain).'
                    <input type="text" name ="'.$this->plugin_prefix.'att_sheet_ne'.'" value="" /></td>
                    <td><input type="submit" name ="'.$this->plugin_prefix.'get_att_sheet'.'" value="'.__('Get attendance sheet', $this->plugin_textdomain).'" /></td>
                    </tr>';    
                ?>
                </table>   
                </form>    
                <?php
            } else {
                
              _e('No subscribers yet', $this->plugin_textdomain);
                
            }
 
            
        }
                
         public function issue_documents($ID, $list=false, $att=false, $title="", $ne=0) {
 
           global $wpcoop;
          
           // read options 
           $coop_options = get_option($this->plugin_prefix.'options_coop'); 
           $shares_options = get_option($this->plugin_prefix.'options_shares');
           $management_options = get_option($this->plugin_prefix.'options_management');
           // get_option return false if option not exits or has no value : if so redirect to parameters         
           if ( $coop_options===false || $shares_options===false || $management_options===false) {
               wp_redirect(admin_url().'options-general.php?page=wpcoop_options');  
           }
           $logo = $coop_options['logo'];
           $logourl=get_option($this->plugin_prefix.'options_coop_logo_url','hhjhj') ; 
           $company = $coop_options['name'];     
           $emb_company_name = $coop_options['embeded_name'];     
           $address = $coop_options['address'];     
           $town = $coop_options['town'];     
           $policies = $coop_options['policies']; 
           $pps = $this->get_share_price();
           $auth_title = $management_options['title']; 
           $auth_name = $management_options['name']; 
           $auth_signature = $management_options['signature']; 
           
             // create read images authorization token
           $token=wp_create_nonce('coop_get_image');
           // have to authentify image request source without cookies -> use options
           update_option($wpcoop->plugin_prefix.'getimagetoken',$token);
             
           //get company logo
           $url= get_option($wpcoop->plugin_prefix.'options_coop_logo_url');
           $url_logo = str_replace('TOKEN','getimagetoken='.$token, $url);
           wlog(LOG, 'issue_documents url_logo '.$url_logo);
             
           //get authority signature
           $url= get_option($wpcoop->plugin_prefix.options_management_signature_url);
           $url_signature = str_replace('TOKEN','getimagetoken='.$token, $url);
           wlog(LOG, 'issue_documents url_signature '.$url_signature);
             
           //     
           if ($att==1) {
            include('gen-att.php');
           } elseif ($list==1) { 
            include('gen-list.php');
           } elseif ($list==2) { 
            include('gen-oreg.php');
           } elseif ($list==3) { 
            include('gen-subs2val.php');
           } else {
            include('gen-doc.php');
           }
           update_option($wpcoop->plugin_prefix.'getimagetoken','');     
         }
      
        
        public function get_users($ID, $select='') {
            // $id==0 -> all users
            // select='' -> subscribers and not yet subscribers
            // select= 'subs -> subscribers only
            if ($ID==0) {
                $options=array();
                if ($select=='subs') {
                 $options=array( 'meta_key'=>$this->plugin_usersubs_meta);
                }
            } else {
                $options=array('include'=>array($ID));
                if ($select=='subs') {
                 $options=array( 'include'=>array($ID), 'meta_key'=>$this->plugin_usersubs_meta);
                }
            } 
            return get_users( $options  ); 
        }
      
        public function get_ordered_users($select="all", $order="lastname") {
            // $select='all' -> all users, 'subs' subscriber only, int userid    
            // set some data
            $users=$this->get_users(($select=="all" || $select=="subs")? 0 : intval($select), ($select=="all")? '' : 'subs');
            //print_tab($users);
            $fields=$this->get_added_profile_fields();
            //print_tab($fields);
            $category_fields=$this->get_added_profile_category_fields();
            //print_tab($category_fields); 
            //$possible_statuses=$this->get_possible_statuses();
            //print_tab($possible_statuses);

            $opst=array();
            foreach($users as $user) {
             //echo $user->ID.' '.$user->login.' '.$user->display_name.'<br>';
             $opst[$user->ID]['usersubs']=get_user_meta($user->ID, $this->plugin_usersubs_meta, true); 
             $opst[$user->ID]['last_name']=get_user_meta($user->ID, 'last_name', true); 
             $opst[$user->ID]['first_name']=get_user_meta($user->ID, 'first_name', true); 
             $opst[$user->ID]['display_name']=$user->display_name;   
             $opst[$user->ID]['user_login']=$user->user_login;   
             $opst[$user->ID]['user_email']=$user->user_email;   
              //$opst[$user->ID][$opst[$user->ID]];   

             foreach($fields as $k=>$v) {
              $opst[$user->ID][$k]=get_user_meta($user->ID,$k, true);    
             }

             foreach  ($category_fields as $k=>$field) {
              $opst[$user->ID][$field['name']] = get_user_meta($user->ID, $field['name'], true);  

             }  
            }

            $subs=array();
            foreach($opst as $id=>$user) { 
               $subs[$id]=$user['last_name'].$user['first_name']; 
            }

            natcasesort($subs);

            $ops=array();
            foreach($subs as $k=>$n ) {
              $ops[$k]= $opst[$k]; 
            }
            return $ops;
        }
      
      
        // get subscriber total subscriptions amount
      
      
      
        // gestion des champs supplementaires
      
        public function get_user_data_fields() {

            return array(
             // xxx string exists in WP -> __('xxx') 
             // xxx string doesn't exist in WP, translate it in plugin and -> __('xxx', $this->plugin_textdomain)        
             'user_login'=>array('name'=>'pre_user_login',
                                 'label'=>__('Username'),
                                 'desc'=>__('Username')),
             'user_url'=>array('name'=>'pre_user_url',
                                 'label'=>__('Website'),
                                 'desc'=>__('Website')),
             'user_email'=>array('name'=>'pre_user_email',
                                 'label'=>__('Email'),
                                 'desc'=>__('User Email')),
             'nickname'=>array('name'=>'pre_nickname',
                                 'label'=>__('Nickname'),
                                 'desc'=>__('Nickname')),
             'first_name'=>array('name'=>'pre_first_name',
                                 'label'=>__('First Name'),
                                 'desc'=>__('First Name')),
             'last_name'=>array('name'=>'pre_last_name',
                                 'label'=>__('Last Name'),
                                 'desc'=>__('Last Name')), 
             'description'=>array('name'=>'pre_description',
                                 'label'=>__('Description'),
                                 'desc'=>__('Description'))
            /*    
             'user_registered'=>array('name'=>$this->plugin_prefix.'pre_login',
                                 'label'=>__('Login', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)),    
             'role'=>      array('name'=>$this->plugin_prefix.'pre_login',
                                 'label'=>__('Login', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)),
             'display_name'=>array('name'=>$this->plugin_prefix.'pre_display_name',
                                 'label'=>__('Display Name', $this->plugin_textdomain),
                                 'desc'=>__('Id', $this->plugin_textdomain)), 
            */ 
       
            );
         
        }
      
       public function modify_contactmethods($profile_fields) {
            // Add new fields
            foreach($this->get_added_profile_fields() as $k=>$v) {
              $profile_fields[$k]=$v;  
            }
	        return $profile_fields;
        }
      

        public function get_added_profile_fields() {
            return apply_filters('added_profile_fields', array(
                $this->plugin_prefix.'phone'    => __('Phone', $this->plugin_textdomain),
                $this->plugin_prefix.'adr1'     => __('Address', $this->plugin_textdomain),
                $this->plugin_prefix.'adr2'     => __('Address', $this->plugin_textdomain),
                $this->plugin_prefix.'zip'      => __('Postal Code', $this->plugin_textdomain),
                $this->plugin_prefix.'city'     => __('City', $this->plugin_textdomain),
                $this->plugin_prefix.'country'  => __('Country', $this->plugin_textdomain),
            
            ));
            
            
        } 
                       
        public function get_added_profile_category_fields() {
            return apply_filters('wpcoop_added_profile_category_fields', array(
                 array('id' => $this->plugin_prefix.'forme', 'name'=>$this->plugin_prefix.'forme', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Forme', $this->plugin_textdomain), 'desc'=>__('M., Mme, Société, Association...', $this->plugin_textdomain)), 
                 array('id' => $this->plugin_prefix.'company', 'name'=>$this->plugin_prefix.'company', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Raison sociale', $this->plugin_textdomain), 'desc'=>__('Pour les personnes morales', $this->plugin_textdomain)), 
                 array('id' => $this->plugin_prefix.'birthname', 'name'=>$this->plugin_prefix.'birthname', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Birth Name', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Name if different from your name', $this->plugin_textdomain)), 
                 array('id' => $this->plugin_prefix.'birthdate', 'name'=>$this->plugin_prefix.'birthdate', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Birth date', $this->plugin_textdomain), 'desc'=>__('Enter you Birth Date', $this->plugin_textdomain)), 
                 array('id' => $this->plugin_prefix.'birthcountry', 'name'=>$this->plugin_prefix.'birthcountry', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Birth place', $this->plugin_textdomain), 'desc'=>__('Enter you Birth place', $this->plugin_textdomain)), 
                 array('id' => $this->plugin_prefix.'nationality', 'name'=>$this->plugin_prefix.'nationality', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Nationality', $this->plugin_textdomain), 'desc'=>__('Nationality', $this->plugin_textdomain)),
                 array('id' => $this->plugin_prefix.'job', 'name'=>$this->plugin_prefix.'job', 'defvalue'=> __('',$this->plugin_textdomain),
                       'label'=>__('Job', $this->plugin_textdomain), 'desc'=>__('Enter your job', $this->plugin_textdomain))
            
            ));
        }                          

        public function save_profile_category_fields( $ID ) {

             if ( !current_user_can( 'edit_user', $user_id ) ) { return false; }
                $fields=$this->get_added_profile_category_fields();
                foreach ($fields as $k=>$v) {
                 wlog(LOG, $v['name']. $_POST[$v['name']]);   
                 update_user_meta( $ID, $v['name'], $_POST[$v['name']] );
                }
      
        }
    
        public function add_profile_category_fields($user) {
            wlog(LOG,$user->ID);
            ?>           
            <h3><?php _e('Etat civil', $this->plugin_textdomain) ?></h3>
                <table class="form-table">
            <?php
                
            foreach ($this->get_added_profile_category_fields() as $k=>$v) {
            ?>    
                    <tr>
                    <th><label for="<?php echo esc_attr($v['id']); ?>"><?php echo $v['label']; ?></label></th>
                    <td>
                    <input type="text" id="<?php echo esc_attr($v['id']); ?>"
                           name="<?php echo esc_attr($v['name']); ?>" 
                           size="20"
                           value="<?php echo esc_attr( get_the_author_meta( $v['name'], $user->ID )); ?>">
                    <span class="description"><?php echo sanitize_text_field( $v['desc']); ?></span>
                    </td>
                    </tr>
            <?php
            }
            ?>           
            </table>           
            <?php           
      
        }
        
       public function display_user_subs_table($userid, $usersubs, $form=false) {
            
         if (is_array($usersubs) && !empty($usersubs)) {
             
            echo '
            <table border="1">
            <caption>Historique des opérations</caption>
            <thead>
                <tr><th>'.__('Date (jj/mm/aaaa)', $this->plugin_textdomain).'</th>
                    <th>'.__('Opération', $this->plugin_textdomain).'</th>
                    <th>'.__('Note', $this->plugin_textdomain).'</th>
                    <th style="text-align: right">'.__('Montant/Parts', $this->plugin_textdomain).'</th>';
            if ($form) {
                echo '
                    <th>'.__('Actions', $this->plugin_textdomain).'</th>';
            }
            echo ($form && is_admin() &&  current_user_can('administrator'))? '<th>'.__('Admin actions', $this->plugin_textdomain).'</th></tr>' : '</tr>';
             
            echo'                                                                               
            </tr>
            </thead>';
            if ($form) {
                echo'    
                <form action="'.admin_url('admin.php?page=add2').'" method="post" >';
                echo wp_nonce_field( 'wpcoopsubpage2', $this->plugin_prefix.'wpnonce', true, false );
                echo '    
                <input type="hidden" name="'.esc_attr($this->plugin_prefix.'userid').'" value="'.esc_attr($userid).'" />'; 
            }
            $p=0;
            $v=0;
            $sh=$this->is_shareholder($usersubs); 
            foreach($usersubs as $o=>$steps) {
                foreach($steps as $i=>$step) {
                    $unit= (strlen($step['s'])>5 && substr($step['s'],0,5)=='share')? 'Part(s)' : '€';
                    if ($unit=='€') { 
                     $q= $step['q'];
                     $v+=$q;    
                    } else {
                     $q= $step['q'] / $this->get_share_price();
                     $s+=$q;   
                    }
                    if ($form) {
                        // possible next steps, only if step is the last in this operation
                        $buttons='';
                        if (count($usersubs[$o])-1==$i) {
                            $pns=$this->workflow[$step['s']]; 
                            foreach($pns as $ns) {
                                $buttons.='<input type="submit" name="'.$this->plugin_prefix.$ns['action'].$userid.'_'.$o.'_'.$i.'" value="'.esc_attr($ns['button']).'" />';  
                            }
                        }
                    }
                    /*
                    // reverse date
                    $d=substr($l['d'],4,4).substr($l['d'],2,2).substr($l['d'],0,2);
                    $temp[$d][$o][]=$l;*/
                    echo '<tr>  <td>'.esc_html(substr($step['d'],0,2).'/'.substr($step['d'],2,2).'/'.substr($step['d'],4,4)).'</td><td>'.esc_html($o).'- '.esc_html($this->possible_statuses[$step['s']]).'</td><td>'.wp_kses_stripslashes(esc_html($step['n'])).'</td>
                            <td style="text-align: right">'.esc_html($q).' '.esc_html($unit).'</td>';
                    if ($form) {
                      echo '<td>
                                '.$buttons.'
                            </td>';
                    }
                    echo ($form && is_admin() && current_user_can('administrator'))? 
                            '<td>
                             <input type="submit" name="'.$this->plugin_prefix.'edit'.$userid.'_'.$o.'_'.$i.'" value="'.esc_attr(__('Edit!',$this->plugin_textdomain)).'" />
                             <input type="submit" name="'.$this->plugin_prefix.'delete'.$userid.'_'.$o.'_'.$i.'" value="'.esc_attr(__('Delete!',$this->plugin_textdomain)).'" />
                            </td>
                          </tr>' :
                         '</tr>';
                }



            }
                /*
                ksort($temp);
                //rint_tab($temp);

            foreach($temp as $d=>$us) {
                echo '<tr>  <td>'.substr($d,7,2).'/'.substr($d,5,2).'/'.substr($d,0,4).'</td><td>'.$this->possible_statuses[$us['s']].'</td>
                            <td style="text-align: right">'.$us['q'].' '.$unit.'</td>
                     </tr>';


            }       
            */ 

            $add = ($form && is_admin() && current_user_can('administrator'))? '<td></td>' : ''; 
            if ($form) {
                $add.='<td></td>';
                echo '
                    <tr><td colspan="3" style="text-align: right">'.__('Date Action (jj/mm/aaaa)', $this->plugin_textdomain).'</td>
                    <td><input type="input" name="'.$this->plugin_prefix.'newdate" /></td>'.$add.'</tr>
                    <tr><td colspan="3" style="text-align: right">'.__('Note Action', $this->plugin_textdomain).'</td>
                    <td><input type="input" name="'.$this->plugin_prefix.'newnote" /></td>'.$add.'</tr>
                    </form>';
            }
            echo '
            <tfoot>
                <tr><td colspan="2" >'.__("Number of validated shares", $this->plugin_textdomain).'</td><td style="text-align: right">'.$s.' Part(s)</td>'.$add.'</tr>
            </tfoot>
            </table>';

            }// display table if there are subscriptions
    
        } // display user subs table
      
        public function is_shareholder($usersubs) {
           $sh=false;    
           foreach($usersubs as $o=>$steps) {
             foreach($steps as $step) {  
              if ($step['s']=='shareok' || $step['s']=='sharenok') {$sh=true; break 2;}
             }
           }
           return $sh;
        }
      
      
      
  } //class
} // if class exits