// counters
// alain messin
// 20170903
//
//


  var wpcoounters = {
 
   
   // From Mark Crossley - Animated Canvas Odometer
   // http://www.wilmslowastro.com/odometer/odometer.html     
   odometer: function (ctx, parameters) {
    parameters = parameters || {};
    var height = (undefined === parameters.height ? 40 : parameters.height);
    var digits = (undefined === parameters.digits ? 6 : parameters.digits);
    var decimals = (undefined === parameters.decimals ? 0 : parameters.decimals);
    var decimalBackColor = (undefined === parameters.decimalbackcolor ? '#F0F0F0' : parameters.decimalbackcolor);
    var decimalForeColor = (undefined === parameters.decimalforecolor ? '#F01010' : parameters.decimalforecolor);
    var font = (undefined === parameters.font ? 'sans-serif' : parameters.font);
    var value = (undefined === parameters.value ? 0 : parameters.value);
    var valueBackColor = (undefined === parameters.valuebackcolor ? '#050505' : parameters.valuebackcolor);
    var valueForeColor = (undefined === parameters.valueforecolor ? '#F8F8F8' : parameters.valueforecolor);
    var wobbleFactor = (undefined === parameters.wobblefactor ? 0.2 : parameters.wobblefactor);

    var doc = document;
    var initialized = false;
    
    // Cannot display negative values yet
    if (value < 0) {
        value = 0;
    }

    var digitHeight = Math.floor(height * 0.85);
    var stdFont = '600 ' + digitHeight + 'px ' + font;
    
    var digitWidth = Math.floor(height * 0.68);
    var width = digitWidth * (digits + decimals);
    var columnHeight = digitHeight * 11;
    var verticalSpace = columnHeight / 12;
    var zeroOffset = verticalSpace * 0.85;
    
    var wobble = [];

    // Resize and clear the main context
    ctx.canvas.width = width;
    ctx.canvas.height = height;

    // Create buffers
    var backgroundBuffer = createBuffer(width, height);
    var backgroundContext = backgroundBuffer.getContext('2d');
    
    var foregroundBuffer = createBuffer(width, height);
    var foregroundContext = foregroundBuffer.getContext('2d');
    
    var digitBuffer = createBuffer(digitWidth, columnHeight * 1.1);
    var digitContext = digitBuffer.getContext('2d');

    var decimalBuffer = createBuffer(digitWidth, columnHeight * 1.1);
    var decimalContext = decimalBuffer.getContext('2d');
       
    // convert color string hexa (6 digits) to rgb values
    // TODO cope with 3 digits ?   
    function  cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h}        
    function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16)}
    function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16)}
    function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16)}


      
    function init() {
        
        initialized = true;

        // Create the foreground
        foregroundContext.rect(0, 0, width, height);
        gradHighlight = foregroundContext.createLinearGradient(0, 0, 0, height);
        /*
        gradHighlight.addColorStop(0, 'rgba(0, 0, 0, 1)');
        gradHighlight.addColorStop(0.1, 'rgba(0, 0, 0, 0.4)');
        gradHighlight.addColorStop(0.33, 'rgba(255, 255, 255, 0.45)');
        gradHighlight.addColorStop(0.46, 'rgba(255, 255, 255, 0)');
        gradHighlight.addColorStop(0.9, 'rgba(0, 0, 0, 0.4)');
        gradHighlight.addColorStop(1, 'rgba(0, 0, 0, 1)');
        
        gradHighlight.addColorStop(0, 'rgba(255, 255,0, 1)');
        gradHighlight.addColorStop(0.1, 'rgba(255, 200, 100, 0.4)');
        gradHighlight.addColorStop(0.33, 'rgba(255, 200, 100, 0.45)');
        gradHighlight.addColorStop(0.46, 'rgba(255, 200, 100, 0)');
        gradHighlight.addColorStop(0.9, 'rgba(255, 200, 100, 0.4)');
        gradHighlight.addColorStop(1, 'rgba(255, 255, 0, 1)');
        */
        
        
        rvbc= (hexToR(valueBackColor)>5)? hexToR(valueBackColor)-4 : hexToR(valueBackColor)  ;
        gvbc= (hexToG(valueBackColor)>5)? hexToG(valueBackColor)-4 : hexToG(valueBackColor)  ;
        bvbc= (hexToB(valueBackColor)>5)? hexToB(valueBackColor)-4 : hexToR(valueBackColor)  ;
        
        
        gradHighlight.addColorStop(0,    'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.8+')');
        gradHighlight.addColorStop(0.1,  'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.4+')');
        gradHighlight.addColorStop(0.33, 'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.45+')');
        gradHighlight.addColorStop(0.46, 'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.0+')');
        gradHighlight.addColorStop(0.9,  'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.4+')');
        gradHighlight.addColorStop(1,    'rgba('+rvbc+','+gvbc+', '+bvbc+', '+0.8+')');

        
        
        
        foregroundContext.fillStyle = gradHighlight;
        foregroundContext.fill();


        // Create a digit column
        // background
        digitContext.rect(0, 0, digitWidth, columnHeight * 1.1);
        digitContext.fillStyle = valueBackColor;
        digitContext.fill();
        // edges
        digitContext.strokeStyle = '#f0f0f0';
        digitContext.lineWidth = '1px'; //height * 0.1 + "px";
        digitContext.moveTo(0, 0);
        digitContext.lineTo(0, columnHeight * 1.1);
        digitContext.stroke();
        digitContext.strokeStyle = '#909090';
        digitContext.moveTo(digitWidth, 0);
        digitContext.lineTo(digitWidth, columnHeight * 1.1);
        digitContext.stroke();
        // numerals
        digitContext.textAlign = 'center';
        digitContext.textBaseline = 'middle';
        digitContext.font = stdFont;
        digitContext.fillStyle = valueForeColor;
        // put the digits 901234567890 vertically into the buffer
        for (var i=9; i<21; i++) {
            digitContext.fillText(i % 10, digitWidth * 0.5, verticalSpace * (i-9) + verticalSpace / 2);
        }
        
        // Create a decimal column
        if (decimals > 0) {
            // background
            decimalContext.rect(0, 0, digitWidth, columnHeight * 1.1);
            decimalContext.fillStyle = decimalBackColor;
            decimalContext.fill();
            // edges
            decimalContext.strokeStyle = '#f0f0f0';
            decimalContext.lineWidth = '1px'; //height * 0.1 + "px";
            decimalContext.moveTo(0, 0);
            decimalContext.lineTo(0, columnHeight * 1.1);
            decimalContext.stroke();
            decimalContext.strokeStyle = '#909090';
            decimalContext.moveTo(digitWidth, 0);
            decimalContext.lineTo(digitWidth, columnHeight * 1.1);
            decimalContext.stroke();
            // numerals
            decimalContext.textAlign = 'center';
            decimalContext.textBaseline = 'middle';
            decimalContext.font = stdFont;
            decimalContext.fillStyle = decimalForeColor;       
            // put the digits 901234567890 vertically into the buffer
            for (var i=9; i<21; i++) {
                decimalContext.fillText(i % 10, digitWidth * 0.5, verticalSpace * (i-9) + verticalSpace / 2);
            }
        }
        // wobble factors
        for (var i=0; i<(digits + decimals); i++) {
            wobble[i] = Math.random() * wobbleFactor * height - wobbleFactor * height /2;
        }
        
    }
       
    function drawDigits(){
        var pos = 1;
        var val;
        
        val = value;
        // do not use Math.pow() - rounding errors!
        for (var i=0; i<decimals; i++) {
            val *= 10;
        }

        var numb = Math.floor(val);
        var frac = val - numb;
        numb = String(numb);
        var prevNum = 9;

        for (var i = 0; i < decimals + digits; i++) {
            var num = +numb.substring(numb.length - i - 1, numb.length - i) || 0;
            if (prevNum != 9) {
                frac = 0;
            }
            if (i < decimals) {
                backgroundContext.drawImage(decimalBuffer, width - digitWidth * pos, -(verticalSpace * (num + frac) + zeroOffset + wobble[i]));
            } else {
                backgroundContext.drawImage(digitBuffer, width - digitWidth * pos, -(verticalSpace * (num + frac) + zeroOffset + wobble[i]));
            }
            pos++;
            prevNum = num;
        }
    }

    this.setValue = function(newVal) {
        value = newVal;
        if (value < 0) {
            value = 0;
        }
        this.repaint();
    }
    
    this.getValue = function() {
        return value;
    }

    this.repaint = function() {
        if (!initialized) {
            init();
        }
        
        // draw digits
        drawDigits();
        
        // draw the foreground
        backgroundContext.drawImage(foregroundBuffer, 0, 0);
        
        // paint back to the main context
        ctx.drawImage(backgroundBuffer, 0, 0);
        
    }
       
    function createBuffer(width, height) {
        var buffer = doc.createElement('canvas');
        buffer.width = width;
        buffer.height = height;
        return buffer;
    }

   }, // createOdometer
      
      
              

} //

    